%global gohomepath github.com/opencontainers
%global goipath    %{gohomepath}/runc

Summary: runc is a CLI tool for spawning and running containers according to the OCI specification.
Name:    runc
Version: 1.1.12
Release: 2%{?dist}
License: ASL 2.0
URL:     https://%{goipath}
Source0: %{url}/archive/refs/tags/v%{version}.tar.gz
Patch5000: 0001-add-loong64-support-for-libcontainer.patch

BuildRequires: golang glibc-static make libseccomp-devel libseccomp-static
BuildRequires: go-md2man libselinux-devel git go-rpm-macros
Provides: oci-runtime

%description
runc is a CLI tool for spawning and running containers according to the OCI specification.

%prep
%autosetup -n runc-%{version} -p1 -Sgit

%build
export CGO_CFLAGS=$CFLAGS
export BUILDTAGS="seccomp selinux"
CGO_CFLAGS=$(echo $CGO_CFLAGS | sed 's/-flto=auto//g')

%ifarch x86_64
export CGO_CFLAGS+=" -m64 -mtune=generic -fcf-protection=full"
%endif

export GOPATH=$PWD/.gopath
mkdir -p ${GOPATH}/src/%{gohomepath}
ln -sfn $PWD $GOPATH/src/%{goipath}
export LDFLAGS="-X main.version=%{version}"
%gobuild -o runc %{goipath}

%install
install -p -Dm 755 runc %{buildroot}/%{_bindir}/runc

man/md2man-all.sh
install -d -p %{buildroot}%{_mandir}/man8
install -p -m 0644 man/man8/*.8 %{buildroot}%{_mandir}/man8/.

install -d -p %{buildroot}%{_datadir}/bash-completion/completions
install -p -Dm 0644 contrib/completions/bash/%{name} \
    %{buildroot}%{_datadir}/bash-completion/completions/%{name}

%files
%license LICENSE
%doc MAINTAINERS_GUIDE.md PRINCIPLES.md README.md CONTRIBUTING.md
%{_bindir}/%{name}
%{_datadir}/bash-completion/completions/%{name}
%{_mandir}/man8/%{name}*

%changelog
* Tue Mar 19 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 1.1.12-2
- add loong64 support for runc

* Sun Feb 18 2024 Kui Ji <jackeyji@tencent.com> - 1.1.12-1
- upgrade to 1.1.12

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.7-3
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 02 2023 Kui Ji <jackeyji@tencent.com> - 1.1.7-2
- fix version bugs

* Tue Jul 18 2023 Kui Ji <jackeyji@tencent.com> - 1.1.7-1
- upgrade to 1.1.7

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.4-6
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.4-5
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 26 2022 Shuo Wang <abushwang@tencent.com> - 1.1.4-4
- provides oci-runtime

* Fri Dec 16 2022 Shuo Wang <abushwang@tencent.com> - 1.1.4-3
- apply %gobuild macro and enable debuginfo

* Thu Dec 15 2022 Shuo Wang <abushwang@tencent.com> - 1.1.4-2
- enable man

* Wed Dec 14 2022 Shuo Wang <abushwang@tencent.com> - 1.1.4-1
- initial build
